# Uvicore Vue3 Library


## Build
```bash
npm init @vitejs/app  # select vue with vue-ts
npm install --save-dev @types/node
```








This template should help get you started developing with Vue 3 and Typescript in Vite.

## Recommended IDE Setup

[VSCode](https://code.visualstudio.com/) + [Vetur](https://marketplace.visualstudio.com/items?itemName=octref.vetur). Make sure to enable `vetur.experimental.templateInterpolationService` in settings!

### If Using `<script setup>`

[`<script setup>`](https://github.com/vuejs/rfcs/pull/227) is a feature that is currently in RFC stage. To get proper IDE support for the syntax, use [Volar](https://marketplace.visualstudio.com/items?itemName=johnsoncodehk.volar) instead of Vetur (and disable Vetur).

## Type Support For `.vue` Imports in TS

Since TypeScript cannot handle type information for `.vue` imports, they are shimmed to be a generic Vue component type by default. In most cases this is fine if you don't really care about component prop types outside of templates. However, if you wish to get actual prop types in `.vue` imports (for example to get props validation when using manual `h(...)` calls), you can use the following:

### If Using Volar

Run `Volar: Switch TS Plugin on/off` from VSCode command palette.

### If Using Vetur

1. Install and add `@vuedx/typescript-plugin-vue` to the [plugins section](https://www.typescriptlang.org/tsconfig#plugins) in `tsconfig.json`
2. Delete `src/shims-vue.d.ts` as it is no longer needed to provide module info to Typescript
3. Open `src/main.ts` in VSCode
4. Open the VSCode command palette
5. Search and run "Select TypeScript version" -> "Use workspace version"

















{
  "name": "@uvicore/vue3",
  "version": "0.0.1",
  "description": "Uvicore Vue3 Support Library",
  "files": [
    "dist"
  ],
  "main": "dist/vue3.umd.js",
  "module": "dist/vue3.es.js",
  "exports": {
    ".": {
      "import": "./dist/vue3.es.js",
      "require": "./dist/vue3.umd.js"
    }
  },
  "scripts": {
    "dev": "vite",
    "build": "vue-tsc --noEmit && vite build",
    "build2": "vue-tsc --declaration --esModuleInterop --outDir dist",
    "serve": "vite preview"
  },
  "dependencies": {
    "vue": "^3.0.11"
  },
  "devDependencies": {
    "@types/node": "^15.12.2",
    "@vitejs/plugin-vue": "^1.2.3",
    "@vue/compiler-sfc": "^3.0.5",
    "rollup-plugin-typescript2": "^0.30.0",
    "tslib": "^2.3.0",
    "typescript": "^4.3.2",
    "vite": "^2.3.7",
    "vite-plugin-dts": "^0.5.1",
    "vue-tsc": "^0.0.24"
  }
}
